/***************************************************************************
                          kcmkeafnode4.h  -  description                              
                             -------------------                                         
    begin                : Tue Aug 10 1999                                           
    copyright            : (C) 1999 by Guenter Schwann                         
    email                : vogel@ibk.dyn.priv.at                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#ifndef __Kcmkeafnode4_h_included__
#define __Kcmkeafnode4_h_included__

#include <qlayout.h>
#include <qcheckbox.h>
#include <qsize.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qstring.h>

#include <kcontrol.h>
#include <kapp.h>
#include <kconfig.h>
#include <kintegerline.h>
#include "parser.h"

class KDEkeafConfig4 : public KConfigWidget
{
    Q_OBJECT

public:
    KDEkeafConfig4(Parser *p, QWidget *parent=0, const char *name=0);
    ~KDEkeafConfig4();

public slots:
    void loadSettings();
    void applySettings();
    void defaultSettings();
    void updateSettings();

private slots:
  void fetchData();

private:
  QString conf_file;

 int maxfetch;
 int initfetch;
 bool delaybody;
 int maxcrosspost;
 int maxage;
 int maxlines;
 int minlines;
 int maxbytes;
 int timeoutshort;
 int timeoutlong;
 int timeoutactive;
 bool createalllinks;
 QString hname;


 KIntegerLine *mfetch;
 KIntegerLine *ifetch;
 QCheckBox *delayb;
 KIntegerLine *maxcross;
 KIntegerLine *mage;
 KIntegerLine *malines;
 KIntegerLine *milines;
 KIntegerLine *mbytes;
 KIntegerLine *timeoutsh;
 KIntegerLine *timeoutlo;
 KIntegerLine *timeoutact;
 QCheckBox *alllinks;
 QLineEdit *honame;

 Parser *pars;
};


#endif

